"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _socket = require("socket.io");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
class SocketIoClass {
  static getInstance(server, options = {}) {
    if (!SocketIoClass.instance) {
      SocketIoClass.instance = new SocketIoClass(server, options);
    }
    return SocketIoClass.instance;
  }
  constructor(server, options) {
    _defineProperty(this, "socketClient", void 0);
    _defineProperty(this, "members", {});
    if (JSON.stringify(options) === "{}") options = {
      pingInterval: 5000,
      withCredentials: true,
      cors: {
        origin: "*"
      }
    };
    this.socketClient = new _socket.Server(server, options);
  }
  addMember(id, socket) {
    this.members[id] = socket;
  }
  delMember(id) {
    if (this.members[id]) delete this.members[id];
  }
  async toMember(id, data) {
    try {
      //逻辑代码
      if (this.members[id]) await this.members[id].emit(data !== null && data !== void 0 && data.emit ? data.emit : "toMember", data !== null && data !== void 0 && data.data ? data.data : {});
      return Promise.resolve(true);
    } catch (e) {
      return Promise.reject(e);
    }
  }
  async toAll(data) {
    try {
      await this.socketClient.emit(data !== null && data !== void 0 && data.emit ? data.emit : "toAll", data !== null && data !== void 0 && data.data ? data.data : {});
      //逻辑代码
      return Promise.resolve(true);
    } catch (e) {
      return Promise.reject(e);
    }
  }
}
_defineProperty(SocketIoClass, "instance", void 0);
var _default = exports.default = SocketIoClass.getInstance;